/**
 * This class is generated by jOOQ
 */
package com.flamesgroup.storage.jooq.tables;


import com.flamesgroup.antrax.commons.VoipAntiSpamListNumbersStatus;
import com.flamesgroup.storage.convert.DateConverter;
import com.flamesgroup.storage.convert.VoipAntiSpamListNumbersStatusConverter;
import com.flamesgroup.storage.jooq.Keys;
import com.flamesgroup.storage.jooq.Public;
import com.flamesgroup.storage.jooq.tables.records.VoipAntiSpamWhiteListNumbersRecord;

import java.util.Arrays;
import java.util.Date;
import java.util.List;

import org.jooq.Field;
import org.jooq.Table;
import org.jooq.TableField;
import org.jooq.UniqueKey;
import org.jooq.impl.TableImpl;


/**
 * This class is generated by jOOQ.
 */
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class VoipAntiSpamWhiteListNumbers extends TableImpl<VoipAntiSpamWhiteListNumbersRecord> {

	private static final long serialVersionUID = 1721727252;

	/**
	 * The reference instance of <code>public.voip_anti_spam_white_list_numbers</code>
	 */
	public static final VoipAntiSpamWhiteListNumbers VOIP_ANTI_SPAM_WHITE_LIST_NUMBERS = new VoipAntiSpamWhiteListNumbers();

	/**
	 * The class holding records for this type
	 */
	@Override
	public Class<VoipAntiSpamWhiteListNumbersRecord> getRecordType() {
		return VoipAntiSpamWhiteListNumbersRecord.class;
	}

	/**
	 * The column <code>public.voip_anti_spam_white_list_numbers.number</code>.
	 */
	public final TableField<VoipAntiSpamWhiteListNumbersRecord, String> NUMBER = createField("number", org.jooq.impl.SQLDataType.CLOB.nullable(false), this, "");

	/**
	 * The column <code>public.voip_anti_spam_white_list_numbers.status</code>.
	 */
	public final TableField<VoipAntiSpamWhiteListNumbersRecord, VoipAntiSpamListNumbersStatus> STATUS = createField("status", org.jooq.impl.SQLDataType.CLOB.nullable(false).defaulted(true), this, "", new VoipAntiSpamListNumbersStatusConverter());

	/**
	 * The column <code>public.voip_anti_spam_white_list_numbers.add_time</code>.
	 */
	public final TableField<VoipAntiSpamWhiteListNumbersRecord, Date> ADD_TIME = createField("add_time", org.jooq.impl.SQLDataType.TIMESTAMP.nullable(false).defaulted(true), this, "", new DateConverter());

	/**
	 * The column <code>public.voip_anti_spam_white_list_numbers.routing_request_count</code>.
	 */
	public final TableField<VoipAntiSpamWhiteListNumbersRecord, Integer> ROUTING_REQUEST_COUNT = createField("routing_request_count", org.jooq.impl.SQLDataType.INTEGER.defaulted(true), this, "");

	/**
	 * Create a <code>public.voip_anti_spam_white_list_numbers</code> table reference
	 */
	public VoipAntiSpamWhiteListNumbers() {
		this("voip_anti_spam_white_list_numbers", null);
	}

	/**
	 * Create an aliased <code>public.voip_anti_spam_white_list_numbers</code> table reference
	 */
	public VoipAntiSpamWhiteListNumbers(String alias) {
		this(alias, VOIP_ANTI_SPAM_WHITE_LIST_NUMBERS);
	}

	private VoipAntiSpamWhiteListNumbers(String alias, Table<VoipAntiSpamWhiteListNumbersRecord> aliased) {
		this(alias, aliased, null);
	}

	private VoipAntiSpamWhiteListNumbers(String alias, Table<VoipAntiSpamWhiteListNumbersRecord> aliased, Field<?>[] parameters) {
		super(alias, Public.PUBLIC, aliased, parameters, "");
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public UniqueKey<VoipAntiSpamWhiteListNumbersRecord> getPrimaryKey() {
		return Keys.VOIP_ANTI_SPAM_WHITE_LIST_NUMBERS_PKEY;
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public List<UniqueKey<VoipAntiSpamWhiteListNumbersRecord>> getKeys() {
		return Arrays.<UniqueKey<VoipAntiSpamWhiteListNumbersRecord>>asList(Keys.VOIP_ANTI_SPAM_WHITE_LIST_NUMBERS_PKEY);
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public VoipAntiSpamWhiteListNumbers as(String alias) {
		return new VoipAntiSpamWhiteListNumbers(alias, this);
	}

	/**
	 * Rename this table
	 */
	public VoipAntiSpamWhiteListNumbers rename(String name) {
		return new VoipAntiSpamWhiteListNumbers(name, null);
	}
}
